import React from "react";
import { View, StyleSheet } from "react-native";
import { createStackNavigator } from "@react-navigation/stack";
import ConfigScreen from "../screens/ConfigScreen";
import MainScreen from "../screens/MainScreen";

function AppNavigation(props) {
  const Stack = createStackNavigator();

  return (
    <Stack.Navigator initialRouteName="ConfigScreen">
      <Stack.Screen
        name="ConfigScreen"
        component={ConfigScreen}
        options={{ headerShown: false }}
      />
      <Stack.Screen
        name="MainScreen"
        component={MainScreen}
        options={{ headerShown: false }}
      />
    </Stack.Navigator>
  );
}

const styles = StyleSheet.create({
  container: {},
});

export default AppNavigation;
