#!/usr/bin/env python

from simple_websocket_server import WebSocketServer, WebSocket
import array
import sys
import time
import os
import socket

sys.path.insert(0, '/home/german/Desktop/RE/TurtleBots.activity/plugins/butia')
from pybot import usb4butia

clearConsole = lambda: os.system('cls'
                                 if os.name in ('nt', 'dos') else 'clear')
clearConsole()

rb = usb4butia.USB4Butia(debug=0)

t = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
t.connect(("8.8.8.8", 80))
print('Servidor: ', str(t.getsockname()[0]))
ip = str(t.getsockname()[0])
t.close()

while True:
    puerto = input("Ingrese puerto: ")
    try:
        if (int(puerto) > 65535 or int(puerto) < 0):
            print("Puerto fuera de rango")
        else:
            print("Puerto valido")
            print("Esperando coneccion del cliente...")
            break
    except ValueError:
        print("Puerto no valido, intente de nuevo.")

speed = 0
puerto_gris = 0

while ((rb.getGray(puerto_gris) == -1) and (puerto_gris < 7)):
    puerto_gris = puerto_gris + 1

puerto_distancia = 0
while ((rb.getDistance(port=puerto_distancia) == -1)
       and (puerto_distancia < 7)):
    puerto_distancia = puerto_distancia + 1


def Avanzar(tiempo):
    if (tiempo == 1):
        print("Avanzar " + tiempo + " segundo")
    else:
        print("Avanzar " + tiempo + " segundos")
    rb.set2MotorSpeed(0, speed - 160, 0, speed)
    time.sleep(float(tiempo))
    rb.set2MotorSpeed(0, 0, 0, 0)


def Retroceder(tiempo):
    if (tiempo == 1):
        print("Retroceder " + tiempo + " segundo")
    else:
        print("Retroceder " + tiempo + " segundos")
    rb.set2MotorSpeed(1, speed, 1, speed)
    time.sleep(float(tiempo))
    rb.set2MotorSpeed(0, 0, 0, 0)


def Rotar(direccion, tiempo):
    if (tiempo == 1):
        print("Rotar " + tiempo + " segundo")
    else:
        print("Rotar " + tiempo + " segundos")
    print(direccion)
    if (direccion == "Derecha"):
        rb.set2MotorSpeed(0, speed, 1, speed)
    elif (direccion == "Izquierda"):
        rb.set2MotorSpeed(1, speed, 0, speed)
    time.sleep(float(tiempo))
    rb.set2MotorSpeed(0, 0, 0, 0)


def AvanzarHastaVerColor(color):
    print("Avanzar hasta ver color " + color)
    if (puerto_gris < 7):
        if (color == "blanco"):
            rb.set2MotorSpeed(0, speed, 0, speed)
            while (rb.getGray(puerto_gris) > 26500):
                pass
        elif (color == "negro"):
            rb.set2MotorSpeed(0, speed, 0, speed)
            while rb.getGray(puerto_gris) < 33100:
                pass

        rb.set2MotorSpeed(0, 0, 0, 0)


def AvanzarHastaObstaculo():
    print("Avanzar hasta obstaculo")
    if (puerto_distancia < 7):
        rb.set2MotorSpeed(0, speed, 0, speed)
        while (rb.getDistance(puerto_distancia) > 52000):
            pass
        rb.set2MotorSpeed(0, 0, 0, 0)


def Accion1():
    print("Accion 1")


class main(WebSocket):
    def handle(self):
        if (self.data == "TestConnection"):
            self.send_message("connected\n")
        else:
            msg = self.data.split("\n")
            global speed
            speed = int(msg[len(msg) - 1])
            print("Ejecutando:")
            for i in range(len(msg) - 1):
                arr = msg[i].split("-")
                if (arr[0] == "Avanzar"):
                    Avanzar(arr[1])
                if (arr[0] == "Retroceder"):
                    Retroceder(arr[1])
                elif (arr[0] == "Derecha" or arr[0] == "Izquierda"):
                    Rotar(arr[0], arr[1])
                elif (arr[0] == "AvanzarHastaVerColor"):
                    AvanzarHastaVerColor(arr[1])
                elif (arr[0] == "AvanzarHastaObstaculo"):
                    AvanzarHastaObstaculo()
                elif (arr[0] == "Accion1"):
                    Accion1()
            self.send_message("fin\n")

    def handle_close(self):
        print(self.address, 'Se desconecto el cliente')


server = WebSocketServer(ip, 8000, main)
server.serve_forever()

# #!/usr/bin/env python

# from simple_websocket_server import WebSocketServer, WebSocket
# import array
# import sys
# import time
# import os
# import socket

# sys.path.insert(0, '/home/german/Desktop/RE/TurtleBots.activity/plugins/butia')
# from pybot import usb4butia

# rb = usb4butia.USB4Butia()

# clearConsole = lambda: os.system('cls'
#                                  if os.name in ('nt', 'dos') else 'clear')
# clearConsole()

# t = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
# t.connect(("8.8.8.8", 80))
# print('Servidor: ', str(t.getsockname()[0]))
# ip = str(t.getsockname()[0])
# t.close()

# while True:
#     puerto = input("Ingrese puerto: ")
#     try:
#         if (int(puerto) > 65535 or int(puerto) < 0):
#             print("Puerto fuera de rango")
#         else:
#             print("Puerto valido")
#             break
#     except ValueError:
#         print("Puerto no valido, intente de nuevo.")

# speed = 0
# puerto_gris = 0
# while ((rb.getGray(puerto_gris) == -1) and (puerto_gris < 7)):
#     puerto_gris = puerto_gris + 1
# puerto_distancia = 0
# while (rb.getDistance(puerto_distancia) == -1 and (puerto_distancia < 7)):
#     puerto_distancia = puerto_distancia + 1

# def Avanzar(tiempo):
#     rb.set2MotorSpeed(0, speed, 0, speed)
#     time.sleep(int(tiempo))
#     rb.set2MotorSpeed(0, 0, 0, 0)

# def Rotar(direccion, tiempo):
#     if (direccion == "Derecha"):
#         rb.set2MotorSpeed(0, speed, 0, 0)
#     elif (direccion == "Izquierda"):
#         rb.set2MotorSpeed(0, 0, 0, speed)
#     time.sleep(int(tiempo))
#     rb.set2MotorSpeed(0, 0, 0, 0)

# def AvanzarHastaVerColor(color):
#     if (puerto_gris < 7):
#         if (color == "Blanco"):
#             while (rb.getGray(puerto_gris) > 15000):
#                 rb.set2MotorSpeed(0, speed, 0, speed)
#         elif (color == "Negro"):
#             while (rb.getGray(puerto_gris) < 35000):
#                 rb.set2MotorSpeed(0, speed, 0, speed)
#         rb.set2MotorSpeed(0, 0, 0, 0)

# def AvanzarHastaObstaculo():
#     if (puerto_distancia < 7):
#         while (rb.getDistance(puerto_distancia) < 54000):
#             rb.set2MotorSpeed(0, speed, 0, speed)
#         rb.set2MotorSpeed(0, 0, 0, 0)

# def Accion1():
#     print("Se esta ejecutando la accion 1")

# class main(WebSocket):
#     def handle(self):
#         print(puerto_distancia, puerto_gris)
#         msg = self.data.split("\\n")
#         speed = msg[len(msg) - 1]
#         for i in range(len(msg) - 1):
#             arr = msg[i].split("-")
#             if (arr[0] == "Avanzar"):
#                 Avanzar(arr[1])
#                 self.send_message("fin de accion")
#             elif (arr[0] == "Derecha" or arr[0] == "Izquierda"):
#                 Rotar(arr[0], arr[1])
#             elif (arr[0] == "AvanzarHastaVerColor"):
#                 AvanzarHastaVerColor(arr[1])
#             elif (arr[0] == "AvanzarHastaVerObstaculo"):
#                 AvanzarHastaObstaculo()
#             elif (arr[0] == "Accion1"):
#                 Accion1()

#     def handle_close(self):
#         print(self.address, 'Se desconecto el cliente')

# server = WebSocketServer(ip, puerto, main)
# server.serve_forever()
